//
// OnpointsAPI.swift
//
// Generated by swagger-codegen
// https://github.com/swagger-api/swagger-codegen
//

import Foundation
import Alamofire



open class OnpointsAPI {
    /**
     NWS advisories, watches and warnings for an OnPoint™ point.
     - parameter onpointId: (path) An OnPoint™ ID. 
     - parameter completion: completion handler to receive the data and the error objects
     */
    open class func onpointsOnpointIdGet(onpointId: Int, completion: @escaping ((_ data: NwsWarningsOnpointObj?,_ error: Error?) -> Void)) {
        onpointsOnpointIdGetWithRequestBuilder(onpointId: onpointId).execute { (response, error) -> Void in
            completion(response?.body, error)
        }
    }


    /**
     NWS advisories, watches and warnings for an OnPoint™ point.
     - GET /onpoints/{onpointId}
     - Returns NWS advisories, watches and warnings data for an OnPoint™ point.  **IMPORTANT:** To authenticate to the Weather Source NWS Warnings API, each request must contain your API key set to a custom header named `X-API-KEY`. If you do not have a Weather Source API key [sign up for a free 30-day developer account](https://developer.weathersourceapis.com/account/sign-up/). You may use the evaluation API Key `C0W60UOFRML47ytbXk4xlLBfv` to access example locations found in this documentation.  When using the \\\"Try it out\\\" capability in the documentation, the API key should be added by clicking the green \\\"Authorize\\\" button at the top of the page. 
     - API Key:
       - type: apiKey X-API-KEY 
       - name: ApiKeyAuth
     - examples: [{contentType=application/json, example={
  "warniungs" : [ {
    "phenomCode" : "WI",
    "significance" : "WATCH",
    "timestampExpires" : "2019-12-20T23:00:00-05:00",
    "phenomDesc" : "Wind"
  }, {
    "phenomCode" : "WI",
    "significance" : "WATCH",
    "timestampExpires" : "2019-12-20T23:00:00-05:00",
    "phenomDesc" : "Wind"
  } ],
  "location" : {
    "onpointId" : 10725864,
    "elevation" : 173.5,
    "timezone" : "America/New_York",
    "countryCode" : "US",
    "grid" : "NORTH_AMERICA_GRID",
    "latitude" : 38.8552,
    "countryName" : "United States of America",
    "subdivName" : "Virginia",
    "subdivCode" : "US-VA",
    "longitude" : -77.0513
  },
  "fieldList" : {
    "fields" : {
      "timestampExpires" : "Timestamp as string: RFC 3339",
      "phenomCode" : "String value",
      "phenomDesc" : "String value",
      "significance" : "String value in"
    }
  }
}}]
     - parameter onpointId: (path) An OnPoint™ ID. 

     - returns: RequestBuilder<NwsWarningsOnpointObj> 
     */
    open class func onpointsOnpointIdGetWithRequestBuilder(onpointId: Int) -> RequestBuilder<NwsWarningsOnpointObj> {
        var path = "/onpoints/{onpointId}"
        let onpointIdPreEscape = "\(onpointId)"
        let onpointIdPostEscape = onpointIdPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        path = path.replacingOccurrences(of: "{onpointId}", with: onpointIdPostEscape, options: .literal, range: nil)
        let URLString = SwaggerClientAPI.basePath + path
        let parameters: [String:Any]? = nil

        let url = URLComponents(string: URLString)

        let requestBuilder: RequestBuilder<NwsWarningsOnpointObj>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "GET", URLString: (url?.string ?? URLString), parameters: parameters, isBody: false)
    }

}
